# coding: utf-8

"""
    Fiscal document service API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date, datetime
from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from cloudbeds_fiscal_document.models.government_integration import GovernmentIntegration
from typing import Optional, Set
from typing_extensions import Self

class FiscalDocumentDetailedResponse(BaseModel):
    """
    FiscalDocumentDetailedResponse
    """ # noqa: E501
    id: Optional[StrictStr] = None
    number: Optional[StrictStr] = None
    property_id: Optional[StrictStr] = Field(default=None, alias="propertyId")
    user_id: Optional[StrictStr] = Field(default=None, alias="userId")
    user_full_name: Optional[StrictStr] = Field(default=None, alias="userFullName")
    source_id: Optional[StrictStr] = Field(default=None, alias="sourceId")
    source_kind: Optional[StrictStr] = Field(default=None, alias="sourceKind")
    kind: Optional[StrictStr] = None
    invoice_date: Optional[date] = Field(default=None, alias="invoiceDate")
    file_name: Optional[StrictStr] = Field(default=None, alias="fileName")
    amount: Optional[Union[StrictFloat, StrictInt]] = None
    balance: Optional[Union[StrictFloat, StrictInt]] = None
    due_date: Optional[date] = Field(default=None, alias="dueDate")
    guest_name: Optional[StrictStr] = Field(default=None, alias="guestName")
    status: Optional[StrictStr] = None
    external_source: Optional[StrictStr] = Field(default=None, alias="externalSource")
    external_id: Optional[StrictStr] = Field(default=None, alias="externalId")
    created_at: Optional[datetime] = Field(default=None, alias="createdAt")
    updated_at: Optional[datetime] = Field(default=None, alias="updatedAt")
    government_integration: Optional[GovernmentIntegration] = Field(default=None, alias="governmentIntegration")
    __properties: ClassVar[List[str]] = ["id", "number", "propertyId", "userId", "userFullName", "sourceId", "sourceKind", "kind", "invoiceDate", "fileName", "amount", "balance", "dueDate", "guestName", "status", "externalSource", "externalId", "createdAt", "updatedAt", "governmentIntegration"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FiscalDocumentDetailedResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of government_integration
        if self.government_integration:
            _dict['governmentIntegration'] = self.government_integration.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FiscalDocumentDetailedResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "number": obj.get("number"),
            "propertyId": obj.get("propertyId"),
            "userId": obj.get("userId"),
            "userFullName": obj.get("userFullName"),
            "sourceId": obj.get("sourceId"),
            "sourceKind": obj.get("sourceKind"),
            "kind": obj.get("kind"),
            "invoiceDate": obj.get("invoiceDate"),
            "fileName": obj.get("fileName"),
            "amount": obj.get("amount"),
            "balance": obj.get("balance"),
            "dueDate": obj.get("dueDate"),
            "guestName": obj.get("guestName"),
            "status": obj.get("status"),
            "externalSource": obj.get("externalSource"),
            "externalId": obj.get("externalId"),
            "createdAt": obj.get("createdAt"),
            "updatedAt": obj.get("updatedAt"),
            "governmentIntegration": GovernmentIntegration.from_dict(obj["governmentIntegration"]) if obj.get("governmentIntegration") is not None else None
        })
        return _obj


